Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.cpp	(revision 54)
@@ -45,4 +45,8 @@
 //! \ingroup TLibEncoder
 //! \{
+#if SVC_EXTENSION  
+Int TEncTop::m_iSPSIdCnt = 0;
+Int TEncTop::m_iPPSIdCnt = 0;
+#endif
 
 // ====================================================================================================================
@@ -78,4 +82,10 @@
   m_pcBitCounters          = NULL;
   m_pcRdCosts              = NULL;
+#if REF_IDX_FRAMEWORK
+  memset(m_cIlpPic, 0, sizeof(m_cIlpPic));
+#endif
+#if REF_IDX_MFM
+  m_bMFMEnabledFlag = false;
+#endif
 }
 
@@ -89,9 +99,15 @@
 Void TEncTop::create ()
 {
+#if !SVC_EXTENSION
   // initialize global variables
   initROM();
+#endif
   
   // create processing unit classes
+#if SVC_EXTENSION
+  m_cGOPEncoder.        create( m_layerId );
+#else
   m_cGOPEncoder.        create();
+#endif
   m_cSliceEncoder.      create( getSourceWidth(), getSourceHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
   m_cCuEncoder.         create( g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight );
@@ -268,7 +284,20 @@
   delete[] m_pcRdCosts;
   
+#if !SVC_EXTENSION
   // destroy ROM
   destroyROM();
-  
+#endif
+#if REF_IDX_FRAMEWORK
+  for(Int i=0; i<MAX_NUM_REF; i++)
+  {
+    if(m_cIlpPic[i])
+    {
+      //m_cIlpPic[i]->setPicYuvRec(NULL);
+      m_cIlpPic[i]->destroy();
+      delete m_cIlpPic[i];
+      m_cIlpPic[i] = NULL;
+    }
+  }    
+#endif
   return;
 }
@@ -313,4 +342,11 @@
 
   m_iMaxRefPicNum = 0;
+#if SVC_EXTENSION
+  m_iSPSIdCnt ++;
+  m_iPPSIdCnt ++;
+#endif
+#if REF_IDX_FRAMEWORK
+  xInitILRP();
+#endif
 }
 
@@ -345,5 +381,29 @@
  \retval  iNumEncoded         number of encoded pictures
  */
-Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded )
+#if SVC_EXTENSION
+Void TEncTop::encode( TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int iPicIdInGOP )
+{
+  // compress GOP
+#if RATE_CONTROL_LAMBDA_DOMAIN
+  if ( m_RCEnableRateControl )
+  {
+    m_cRateCtrl.initRCGOP( m_iNumPicRcvd );
+  }
+#endif
+
+  // compress GOP
+  m_cGOPEncoder.compressGOP(iPicIdInGOP, m_iPOCLast, m_iNumPicRcvd, m_cListPic, rcListPicYuvRecOut, accessUnitsOut);
+
+#if RATE_CONTROL_LAMBDA_DOMAIN
+  if ( m_RCEnableRateControl )
+  {
+    m_cRateCtrl.destroyRCGOP();
+  }
+#endif
+  
+  m_uiNumAllPicCoded ++;
+}
+
+Void TEncTop::encodePrep( TComPicYuv* pcPicYuvOrg )
 {
   if (pcPicYuvOrg) {
@@ -359,4 +419,20 @@
     }
   }
+}
+#else
+Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded )
+{
+  if (pcPicYuvOrg) {
+    // get original YUV
+    TComPic* pcPicCurr = NULL;
+    xGetNewPicBuffer( pcPicCurr );
+    pcPicYuvOrg->copyToPic( pcPicCurr->getPicYuvOrg() );
+
+    // compute image characteristics
+    if ( getUseAdaptiveQP() )
+    {
+      m_cPreanalyzer.xPreanalyze( dynamic_cast<TEncPic*>( pcPicCurr ) );
+    }
+  }
   
   if (!m_iNumPicRcvd || (!flush && m_iPOCLast != 0 && m_iNumPicRcvd != m_iGOPSize && m_iGOPSize))
@@ -387,4 +463,5 @@
   m_uiNumAllPicCoded += iNumEncoded;
 }
+#endif
 
 // ====================================================================================================================
@@ -421,6 +498,22 @@
     {
       TEncPic* pcEPic = new TEncPic;
+#if SVC_EXTENSION //Temporal solution, should be modified
+      if(m_layerId > 0)
+      {
+        TEncTop *pcEncTopBase = (TEncTop *)getLayerEnc( m_layerId-1 );
+        if(m_iSourceWidth != pcEncTopBase->getSourceWidth() || m_iSourceHeight != pcEncTopBase->getSourceHeight() )
+        {
+          pcEPic->setSpatialEnhLayerFlag( true );
+        }
+      }
+#endif
+
+#if SVC_UPSAMPLING
+      pcEPic->create( m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, m_cPPS.getMaxCuDQPDepth()+1 ,
+                      m_conformanceWindow, m_defaultDisplayWindow, m_numReorderPics, &m_cSPS);
+#else
       pcEPic->create( m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, m_cPPS.getMaxCuDQPDepth()+1 ,
                       m_conformanceWindow, m_defaultDisplayWindow, m_numReorderPics);
+#endif
       rpcPic = pcEPic;
     }
@@ -429,6 +522,22 @@
       rpcPic = new TComPic;
 
+#if SVC_EXTENSION //Temporal solution, should be modified
+      if(m_layerId > 0)
+      {
+        TEncTop *pcEncTopBase = (TEncTop *)getLayerEnc( m_layerId-1 );
+        if(m_iSourceWidth != pcEncTopBase->getSourceWidth() || m_iSourceHeight != pcEncTopBase->getSourceHeight() )
+        {
+          rpcPic->setSpatialEnhLayerFlag( true );
+        }
+      }
+#endif
+
+#if SVC_UPSAMPLING
+      rpcPic->create( m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, 
+                      m_conformanceWindow, m_defaultDisplayWindow, m_numReorderPics, &m_cSPS);
+#else
       rpcPic->create( m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, 
                       m_conformanceWindow, m_defaultDisplayWindow, m_numReorderPics);
+#endif
     }
     if (getUseSAO())
@@ -450,4 +559,10 @@
 Void TEncTop::xInitSPS()
 {
+#if SVC_EXTENSION
+  m_cSPS.setLayerId(m_layerId);
+#endif
+#if REF_IDX_MFM
+  m_cSPS.setMFMEnabledFlag(m_bMFMEnabledFlag);
+#endif
   ProfileTierLevel& profileTierLevel = *m_cSPS.getPTL()->getGeneralPTL();
   profileTierLevel.setLevelIdc(m_level);
@@ -484,4 +599,7 @@
   m_cSPS.setMinTrDepth    ( 0                   );
   m_cSPS.setMaxTrDepth    ( 1                   );
+#if SVC_EXTENSION
+  m_cSPS.setSPSId         ( m_iSPSIdCnt       );
+#endif
   
   m_cSPS.setPCMLog2MinSize (m_uiPCMLog2MinSize);
@@ -690,4 +808,8 @@
     }
   }
+#if SVC_EXTENSION
+  m_cPPS.setPPSId         ( m_iPPSIdCnt         );
+  m_cPPS.setSPSId         ( m_iSPSIdCnt         );
+#endif
 }
 
@@ -981,3 +1103,44 @@
   }
 }
+
+#if REF_IDX_FRAMEWORK
+Void TEncTop::xInitILRP()
+{
+  if(m_layerId>0)
+  {
+    if (m_cIlpPic[0] == NULL)
+    {
+      for (Int j=0; j<1/*MAX_NUM_REF*/; j++)
+      {
+        m_cIlpPic[j] = new  TComPic;
+        //m_cIlpPic[j]->createWithOutYuv(m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, &m_cSPS, true);
+#if SVC_UPSAMPLING
+        m_cIlpPic[j]->create(m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, &m_cSPS, true);
+#else
+        m_cIlpPic[j]->create(m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, true);
+#endif
+#if REF_IDX_ME_AROUND_ZEROMV || REF_IDX_ME_ZEROMV || ENCODER_FAST_MODE || REF_IDX_MFM
+        m_cIlpPic[j]->setIsILR(true);
+#endif
+        for (Int i=0; i<m_cIlpPic[j]->getPicSym()->getNumberOfCUsInFrame(); i++)
+        {
+          m_cIlpPic[j]->getPicSym()->getCU(i)->initCU(m_cIlpPic[j], i);
+        }
+      }
+    }
+  }
+}
+
+Void TEncTop::setILRPic(TComPic *pcPic)
+{
+  if(m_cIlpPic[0])
+  {
+    //m_cIlpPic[0]->setPicYuvRec(pcPic->getFullPelBaseRec());
+    m_cIlpPic[0]->copyUpsampledPictureYuv(pcPic->getFullPelBaseRec(), m_cIlpPic[0]->getPicYuvRec());
+    m_cIlpPic[0]->getSlice(0)->setPOC(pcPic->getPOC());
+    m_cIlpPic[0]->getPicYuvRec()->setBorderExtension(false);
+    m_cIlpPic[0]->getPicYuvRec()->extendPicBorder();
+  }
+}
+#endif
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncTop.h	(revision 54)
@@ -73,4 +73,11 @@
   UInt                    m_uiNumAllPicCoded;             ///< number of coded pictures
   TComList<TComPic*>      m_cListPic;                     ///< dynamic list of pictures
+#if SVC_EXTENSION 
+  static Int              m_iSPSIdCnt;                    ///< next Id number for SPS    
+  static Int              m_iPPSIdCnt;                    ///< next Id number for PPS    
+#if AVC_SYNTAX
+  fstream*                m_pBLSyntaxFile;
+#endif
+#endif
   
   // encoder search
@@ -122,4 +129,14 @@
   TEncRateCtrl            m_cRateCtrl;                    ///< Rate control class
   
+#if SVC_EXTENSION
+  TEncTop**               m_ppcTEncTop;
+  TEncTop*                getLayerEnc(UInt layer)   { return m_ppcTEncTop[layer]; }
+#endif
+#if REF_IDX_FRAMEWORK
+  TComPic*                m_cIlpPic[MAX_NUM_REF];                    ///<  Inter layer Prediction picture =  upsampled picture 
+#endif
+#if REF_IDX_MFM
+  Bool                    m_bMFMEnabledFlag;
+#endif
 protected:
   Void  xGetNewPicBuffer  ( TComPic*& rpcPic );           ///< get picture buffer which will be processed
@@ -129,5 +146,7 @@
   Void  xInitPPSforTiles  ();
   Void  xInitRPS          ();                             ///< initialize PPS from encoder options
-
+#if REF_IDX_FRAMEWORK
+  Void xInitILRP();
+#endif
 public:
   TEncTop();
@@ -174,4 +193,12 @@
   Void selectReferencePictureSet(TComSlice* slice, Int POCCurr, Int GOPid );
   TComScalingList*        getScalingList        () { return  &m_scalingList;         }
+#if SVC_EXTENSION
+  Void                    setLayerEnc(TEncTop** p) {m_ppcTEncTop = p;}
+  TEncTop**               getLayerEnc()            {return m_ppcTEncTop;}
+  Int                     getPOCLast            () { return m_iPOCLast;               }
+  Int                     getNumPicRcvd         () { return m_iNumPicRcvd;            }
+  Void                    setNumPicRcvd         ( Int num ) { m_iNumPicRcvd = num;      }
+#endif
+
   // -------------------------------------------------------------------------------------------------------------------
   // encoder function
@@ -179,6 +206,24 @@
 
   /// encode several number of pictures until end-of-sequence
+#if SVC_EXTENSION
+#if REF_IDX_FRAMEWORK
+  TComPic** getIlpList() { return m_cIlpPic; }
+  Void setILRPic(TComPic *pcPic);
+#endif
+#if REF_IDX_MFM
+  Void setMFMEnabledFlag       (Bool flag)   {m_bMFMEnabledFlag = flag;}
+  Bool getMFMEnabledFlag()                   {return m_bMFMEnabledFlag;}    
+#endif
+#if AVC_SYNTAX
+  Void      setBLSyntaxFile( fstream* pFile ) { m_pBLSyntaxFile = pFile; }
+  fstream*  getBLSyntaxFile() { return m_pBLSyntaxFile; }
+#endif
+  Void encode( TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
+              std::list<AccessUnit>& accessUnitsOut, Int iPicIdInGOP  );
+  Void encodePrep( TComPicYuv* pcPicYuvOrg );
+#else
   Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
               std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded );  
+#endif
 
   void printSummary() { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded); }
